var finesse = finesse || {};
finesse.gadget = finesse.gadget || {};
finesse.container = finesse.container || {};
clientLogs = finesse.cslogger.ClientLogger || {};

finesse.modules = finesse.modules || {};
finesse.modules.Gadget = (function ($) {
	// define variables
	var cfg;
    var user;
	var toaster = finesse.containerservices.FinesseToaster;
	
	// define functions
	/** user state change function */
	_handleUserChange = function(userevent) {
		console.log("gadget.js > handleUserChange > start");
		console.log("gadget.js > handleUserChange > agent state changed: " + user.getState());
		// check user state
		switch(user.getState()) {
			case finesse.restservices.User.States.NOT_READY:
				console.log("gadget.js > handleUserChange > agent not ready reason code: " + JSON.stringify(user.getReasonCode()));
				var reasonCode = user.getReasonCode();
				if ((reasonCode.systemCode == "true") && (ToasterNotificationConfiguration.reasonCodes.indexOf(null) > -1)) {
			// System not ready reson codes
					console.log("gadget.js > handleUserChange > system reason code, reason code on the list, show notification");
					_showNotReadyToaster(user.getReasonCode());
				}
				else if ((ToasterNotificationConfiguration.reasonCodes.indexOf(reasonCode.label) > -1) || (ToasterNotificationConfiguration.reasonCodes.indexOf(reasonCode.code) > -1)) {
			// User defined reason codes - activate notification
					console.log("gadget.js > handleUserChange > reason code on the list, show notification");
					_showNotReadyToaster(user.getReasonCode());
				}
				else
			// User defined reason codes - don't trigger notification
					console.log("gadget.js > handleUserChange > reason code not on the list, don't show notification");		
				break;
			default:
				console.log("gadget.js > handleUserChange > user in " + user.getState() +  "  state, don't show notification.");
				break;
		}
		console.log("gadget.js > handleUserChange > end");
	},
	/** display toaster function */
	_showNotReadyToaster = function(reason_code) {
		var notificationStartTime;
		console.log("gadget.js > showNotReadyToaster > start");
		// prepare message text - replace keywords
		// %reason_code_name%
		// %reason_code_value%
		var messageText = ToasterNotificationConfiguration.body;
		messageText = messageText.replace('%reason_code_name%', (reason_code.label === undefined ? '' : reason_code.label));
		messageText = messageText.replace('%reason_code_value%', (reason_code.code === undefined ? '' : reason_code.code));
		console.log("gadget.js > showNotReadyToaster > toaster message: " + messageText);
		
		var iconURL = ToasterNotificationConfiguration.icon;
		if (iconURL.indexOf('http') != 0) {
			console.log("gadget.js > showNotReadyToaster > notification icon deployed on finesse server ");
			var baseURL = window.location.href;
			baseURL = baseURL.substring(baseURL.indexOf('url='));
			baseURL = baseURL.substring(0, baseURL.indexOf('#'));
			baseURL = baseURL.split('%3A').join(':').split('%2F').join('/');
			baseURL = baseURL.substring(baseURL.indexOf('3rdpartygadget'));
			baseURL = '/' + baseURL.substring(0, baseURL.lastIndexOf('/') + 1);
			console.log("gadget.js > showNotReadyToaster > gadget base URL: " + baseURL);
			iconURL = baseURL + iconURL;
			console.log("gadget.js > showNotReadyToaster > icon URL: " + iconURL);
		}
		notificationStartTime = Date.now().toString()
		var notification;		
		var notificationType = ToasterNotificationConfiguration.type.toLowerCase() || 'browser';
		console.log("gadget.js > showNotReadyToaster > notification type: " + notificationType);
		switch(notificationType) {
			case 'finesse':
				var notificationOptions = {
					body: messageText,
					icon: iconURL,
					autoClose: ToasterNotificationConfiguration.autoClose,
					tag: 'NotReadyStateChange',
					renotify: true,
					requireInteraction : true,
					showWhenVisible: ToasterNotificationConfiguration.showWhenVisible
				};
				console.log("gadget.js > showNotReadyToaster > show notification");
				notification = toaster.showToaster(ToasterNotificationConfiguration.title, notificationOptions);
				break;
			default:
				var notificationOptions = {
					body: messageText,
					icon: iconURL,
					renotify: true,
					requireInteraction : true,
					tag: 'NotReadyStateChange1'
				};
				
				if (!("Notification" in window)) {}
				else if (Notification.permission === "granted") {
					console.log("gadget.js > showNotReadyToaster > show notification (permissions granted)");
					console.log("gadget.js > showNotReadyToaster > notification start time: " + Date.now().toString());
					notification = new Notification(ToasterNotificationConfiguration.title, notificationOptions);
					if (Number.isInteger(ToasterNotificationConfiguration.autoClose))
						setTimeout(function() { notificationHandler.close(); }, ToasterNotificationConfiguration.autoClose);
				}
				else if (Notification.permission !== 'denied') {
					Notification.requestPermission(function (permission) {
						if (permission === "granted") {
							console.log("gadget.js > showNotReadyToaster > show notification (permissions denied)");
							console.log("gadget.js > showNotReadyToaster > notification start time: " + Date.now().toString());
							notification = new Notification(ToasterNotificationConfiguration.title, notificationOptions);
							if (Number.isInteger(ToasterNotificationConfiguration.autoClose))
								setTimeout(function() { notificationHandler.close(); }, ToasterNotificationConfiguration.autoClose);
						}
					});
				}
				break;
		}
		notification.onclose = function() {
			console.log("gadget.js > notification > onclose > start");
			var notificationEndTime = Date.now().toString();
			var notificationDuration = (notificationEndTime - notificationStartTime)/1000;
			console.log("gadget.js > notification > onclose > notification end time: " + notificationStartTime);
			console.log("gadget.js > notification > onclose > notification end time: " + notificationEndTime);
			console.log("gadget.js > notification > onclose > > notification duration: " + notificationDuration);
			console.log("gadget.js > notification > onclose > end");
		};		
		console.log("gadget.js > showNotReadyToaster > end");
	}

    /** @scope finesse.modules.Test */
    return {
        init : function () {
			
			cfg = finesse.gadget.Config;
			
			finesse.clientservices.ClientServices.init(cfg, false);
			
			clientLogs = finesse.cslogger.ClientLogger;  	
            clientLogs.init(gadgets.Hub, "Test");
		
			toaster.init(cfg, clientLogs);
			
            user = new finesse.restservices.User({
                id: cfg.id, 
                onChange: _handleUserChange
            });
        }
    };
}(jQuery));